<?php
/**
 * Gets all of the property values for one or more assets
 *
 * This function returns the values of all properties for each of the given asset(s).
 *
 * It is used when you either want ALL asset information for display, or when you
 *    are not clear on the structure of ARDI data and would like to process it without
 *    dealing with metadata queries. 
 *
 * @author Steven Harding
 */	

$format = "xml";
if (isset($_REQUEST['format']))
{
	$format = $_REQUEST['format'];
}

$contacttag = 0;

//Locate the 'contact' tag....
$query = $db->query("SELECT id FROM assets WHERE name='Notification Group' AND type=1");
if($row = $query->fetch(PDO::FETCH_ASSOC)) 
{
	$contacttag = $row['id'];
}


ob_start();

echo '<results>';

$groups = array();
$query = $db->query('SELECT id FROM assets JOIN assetrelclosures ON (childasset=assets.id) WHERE parentasset='.$contacttag.' AND type=1 ORDER BY name');
while($row = $query->fetch(PDO::FETCH_ASSOC)) 
{
	$groups[] = $row['id'];
}

$methods = array();
$query = $db->query('SELECT code, parameters FROM notifier_methods');
while($row = $query->fetch(PDO::FETCH_ASSOC)) 
{
	$methods[$row['code']] = $row['parameters'];
}

foreach($groups as $a)
{
	$ass = new Asset($a);
	$props = $ass->GetProperties();
	$ass->GetValues($props);

	echo '<group id="'.$ass->id.'" name="'.$ass->name.'">';
	
	foreach($props as $p)
	{
		if ($p->type == "_NOTIFIERMETHODS")
		{
			//Bingo - we now know which methods to use...
			echo $p->value['methodlist'];
		}
	}
	echo '</group>';
}

foreach($methods as $k => $v)
{
	echo '<method code="'.$k.'">'.$v.'</method>';
}
		
echo '</results>';

if ($format != "xml")
{
	$content = ob_get_clean();
	if ($format == 'json')
	{
		$xml = simplexml_load_string($content);
		$json = json_encode($xml);
		echo $json;
		exit;
	}
}

?>