<?php
if (!isset($_REQUEST['id']))
{
	header("HTTP/1.1 404 Missing Parameters");
	exit;
}

$id = filter_var($_REQUEST['id'],FILTER_VALIDATE_INT);
if ($id === FALSE)
{
	header("HTTP/1.1 404 Missing Parameters");
	exit;
}

require_once($installfolder.'/model/asset.php');
require_once($installfolder.'/model/formatter.php');

?><noticeinfo>
<?php				
		$query = $db->query('SELECT name,assetid,propertyid,expr FROM notifier_notices WHERE id='.$id);
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$assetid = $row['assetid'];
			$propertyid = $row['propertyid'];
			$expression = $row['expr'];
		}
		
		$values = array();
		$query = $db->query('SELECT value,message FROM notifier_noticetext WHERE noticeid='.$id);
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$values[$row['value']] = $row['message'];
		}
		
		if (isset($_REQUEST['value']))
		{
			$val = $_REQUEST['value'];
		}
		$message = "";
		if (isset($values[$val]))
		{
			$message = $values[$val];
			if ($message != "")
			{
				$formatter = new MessageFormatter();
				$formatter->Set('VALUE',$val);
				$message = $formatter->Format($message);
			}
		}
		
		if ($expression == 'A')
		{
			//This is an ALERT.
			$query = $db->query('SELECT alerts.name,assets.name as aname,description,assetid FROM alerts JOIN assets ON (alerts.assetid = assets.id) WHERE alerts.id='.$propertyid);
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				if ($message == "") 
				{
					if (isset($val) && ($val == '0'))
					{
						if ($message == "")
							$message = 'RESOLVED: '.$row['aname'].' '.$row['name'];
					}
					else
						$message = 'RESOLVED: '.$row['aname'].' '.$row['name'];
				
				}
				//print_r($message);
				echo '  <notice><name>'.$message.'</name>';
				if (isset($_REQUEST['value']) && ($_REQUEST['value'] == '0'))
					echo '<desc>The condition that trigged this alert has now ceased.</desc>';
				else
				{
					if ($row['description'] == '')
					{
						echo '<desc>The '.$row['name'].' alert has been tripped and is currently active. For more details on this alert, please see your ARDI server.</desc>';
					}
					else
						echo '<desc>'.$row['description'].'</desc>';
				}
				echo '<footer>This automated alert was sent from the ARDI notification system</footer></notice>';
			}
		}
		else
		{
			$ass = new Asset($assetid);
			require_once($installfolder.'/model/property.php');
			$proplist = Properties::GetAllProperties();
			$px = array();
			foreach($proplist as $prp)
			{
				if ($prp->id == $propertyid)
				{
					$px = $prp;
					break;
				}
			}
			if ($message == "")
			{
				$message = $ass->name.' '.$px->name.' Has Changed To &quot;'.$val.'&quot;';
			}
			echo '  <notice><name>'.$message.'</name><desc>This is a notification that the '.$px->name.' of the '.$ass->GetFullName().' has changed to &quot;'.$val.'&quot;</desc><footer>This automated alert was sent from the ARDI notification system</footer></notice>';
		}
		
		$methodprops = array();
		$methodparams = array();
		$rawparams = array();
		
		//echo '  <methods>';
		$activemethods = array();
		$query = $db->query('SELECT code, parameters FROM notifier_methods');
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			
			//echo '    <method code="'.$row['code'].'">'.$row['parameters'].'</method>';
			$activemethods[] = $row['code'];
			$rawparams[$row['code']] = $row['parameters'];
		}
		//echo '  </methods>';
		
		//OK - get a list of the properties that each method requires...
		$files = glob($installfolder.'/addons/notifier/methods/*.inc');
		foreach($files as $fldr)
		{	
			$inf = pathinfo($fldr);
			if (!isset($rawparams[$inf['filename']])) continue;
			
			include($fldr);
			
			$pr = array();
			
			//Check to see what type of field is required...
			if (isset($method['requires']))
			{
				$pr = $method['requires'];
			}
			
			$methodprops[$inf['filename']] = $pr;
			
			$ams = array();
			$x=-1;
			$bits = explode('|',$rawparams[$inf['filename']]);
			foreach($params as $p)
			{
				$x++;
				if ($p == "") continue;
				$ams[$p] = $bits[$x];
			}
			
			$methodparams[$inf['filename']] = $ams;
		}
		
		echo '  <methods>';
		foreach($methodparams as $pk => $px)
		{
			echo '<method code="'.$pk.'"';
			foreach($px as $k => $v)
			{
				echo ' '.$k.'="'.$v.'"';
			}
			echo '/>';
		}
		echo '</methods>';
		
		//print_r($activemethods);
		
		$methods = array();
		$groups = array();
		$contacts = array();
		$finalcontacts = array();
		$lastgroup = 0;
		
		//Get a list of groups and users associated with them...
		$query = $db->query('SELECT groupid,childasset,name FROM notifier_noticegroups JOIN assetrelclosures ON (parentasset=groupid) JOIN assets ON (childasset = assets.id) WHERE notifier_noticegroups.id='.$id.' AND assets.type=0');

		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			if ($row['groupid'] != $lastgroup)
			{
				$groups[] = $row['groupid'];
				if (!isset($contacts[$row['groupid']]))
					$contacts[$row['groupid']] = array();
				$lastgroup = $row['groupid'];
			}
			
			$contacts[$row['groupid']][] = $row['childasset'];
		}
		
		foreach($groups as $grp)
		{
			//For each group, determine the methods we are using...
			$ass = new Asset($grp);
			$prop = $ass->GetProperties();
			$ass->GetValues($prop);
			
			$methodstouse = "";
			foreach($prop as $p)
			{
				if ($p->type == '_NOTIFIERMETHODS')
				{
					//Bingo, got it!
					//print_r($p->value);
					$methodstouse = $p->value['methodlist'];
					break;
				}
			}
			
			//OK, now list the contacts in this group...
			$methodset = explode(',',$methodstouse);
			foreach($contacts[$grp] as $con)
			{
				if (!isset($finalcontacts[$con]))
				{
					$finalcontacts[$con] = $methodset;
				}
				else
				{
					foreach($methodset as $meth)
					{
						if (!in_array($meth,$finalcontacts[$con]))
						{
							$finalcontacts[$con][] = $meth;
						}
					}
				}
			}
			
		}
		
		foreach($finalcontacts as $k => $v)
		{
			$a = new Asset($k);
			$donealready = array();
			
			$props = $a->GetProperties();
			$a->GetValues($props);
			
			$available = true;
			foreach($props as $dd)
			{
				if ($dd->type == "AVAILABLE")
				{
					if ($dd->value['available'] == 0)
					{
						$available = false;
						break;
					}
				}
			}
			if ($available == false) continue;
			
			echo '   <contact name="'.$a->name.'" id="'.$k.'">';
			foreach($v as $meth)
			{
				if (!in_array($meth,$activemethods)) continue;
				$st = "";
				$tvvalue = "";
				$pass = true;
				foreach($methodprops[$meth] as $mp)
				{
					$found = false;
					foreach($props as $p)
					{
						if ($p->type == $mp)
						{
							$found = true;
							//print_r($p->value);
							foreach($p->value as $vname => $vvalue)
							{
								$st .= ' '.htmlspecialchars($vname).'="'.$vvalue.'"';
								$tvvalue .= $vvalue;
							}
							break;
						}
					}
					if ($found == false) $pass = false;
				}
				if (trim($tvvalue) == "") $pass = false;
				if ($pass == true)
				{
					echo '    <method code="'.$meth.'" '.$st.'/>';
				}
			}
			echo '   </contact>';
			echo "\r\n";
		}
		
		

?>
</noticeinfo>
